				osm-helpers
	Tools to help the maintenance of the OpenStreetMap database

The tools included here mainly help to check that the data in the
OpenStreetMap database complies with a set of rules and create a description
of the proposed changes and upload them to the database.

See the file MIT.X11 for the license details.

To build issue the commands:
	make PREFIX=/usr/local
	make PREFIX=/usr/local install

On Debian systems you will need the following packages:
	mono-gmcs
	mono-cil
	mono-runtime
	libmono-system-web2.0-cil

* osm-check

osm-check can load osm data from a file on disk or directly from
the OpenStreetMap database given a latitude/longitude pair.
The loaded data is checked against a few compliance rules:
	*) no extra whitespace in the middle, the start or the end
	of tag values
	*) abbreviations at the start of tag values are expanded
	*) uniform case of the first word in tag values

The suggested changes to the data are output to stdout or to a file
in an XML format. This file can be inspected for mistakes and then fed to
osm-upload-changes to upload to the OpenStreetMap database server.
Other rules will be added in the next releases.

The rules are described in an XML file, loaded from
$HOME/.config/osm-helpers/osm-check.rules by default (use the --rules
option to specify a different file).

Each abbreviation is specified with the following element:
	<abbr from="abbr." to="Abbreviation" />
where each "abbr." at the start of a tag value is expanded to
"Abbreviation".
See it.osmrules for examples.

The street type names at the start of a tag value are instead specified
with the element:
	<way name="Street" />

Tags or tag-value combinations that are inappropriate for some object types
can be removed with entries like the following:
	<remove type="node" tag="highway" val="secondary" />

* osm-upload-changes

osm-upload-changes takes a file generated by osm-check and uploads the
individual changes one by one, avoiding the overwriting of data as much
as possible (the race window is under one second vs the minutes or hours
when using some other mass-update scripts). This also means that
the uploading process can be somewhat slow (depending mostly on the
performance of the OpenStreetMap server).
A username and password are required to upload the changes: currently they
are read from the file $HOME/.config/osm-helpers/osm-auth, which
contains the username in the first line and the password in the second
or, if that file is not present they can be entered at the console
prompt.

osm-upload-changes prints a dot for each successful upload, an asterisk
for a change skipped because it's no longer valid, a letter if something
failed in the download or in the upload of the data. A sumamry is printed
as well at the end of the process.
The --no-upload option can be used to do everything except the actual
database upload.

Notifications of the changes made to database objects can be sent to the
contributor that last changed the object at osm-check time using the --notify option.
A default message is sent with a detailed list of the changes made. If you want to 
use a different message, specify a template file to use with the option:
	--notify=template_file

The content of the file will be sent as the message, with the following changes:
	@USER@ is changed to the name of the user receiving the message
	@CHANGES@ is replaced with the list of changes

See the template file for an example.

* osm-changes file format

The changes are described in an XML file with the following structure:

a toplevel element (osmchanges) that contains a list of node, way or
relation elements. Each of these elements must contain an id attribute
(whis is the OpenStreetMap id), a tag attribute with the name of the tag
to change, an old attribute with the value that should be changed and a new
attribute with the new value for the tag. If at the time of the upload
the tag value in the database doesn't match the old value, the update is
skipped. There is also a user attribute: this was the user that last changed
the object at the time the object was checked with osm-check.

* osm-history

osm-history can be used to download the history of an object in the osm db
and have a summary of the differences between each revision.

